// File    : HEAPVIEW.CPP
// Author  : Eric Woodruff,  CIS ID: 72134,1150
// Updated : Thu 02/17/94 19:51:25
// Note    : Copyright 1993-94, Eric Woodruff, All rights reserved
// Compiler: Borland C++ 3.1/4.0
//
// This file contains the Heap View class.
//

#include <alloc.h>
#include <stdio.h>
#include <string.h>

#define Uses_TRect
#define Uses_TView
#include <tv.h>

#include <heapview.h>

//
// Heap Viewer functions
//
THeapView::THeapView(TRect &r) : TView(r)
{
    oldMem = 0L;
    update();
}

void THeapView::draw()
{
    TDrawBuffer b;
    char c = getColor(2);

    b.moveChar(0, ' ', c, size.x);
    b.moveStr(0, heapStr, c);
    writeLine(0, 0, size.x, 1, b);
}

void THeapView::update()
{
    long total;
    struct farheapinfo heap;

    switch(farheapcheck())
    {
        case _HEAPEMPTY:
            strcpy(heapStr, "No heap!");
            total = -1;
            break;

        case _HEAPCORRUPT:
            strcpy(heapStr, "Heap corrupt!");
            total = -2;
            break;

        case _HEAPOK:
            total = farcoreleft();

            heap.ptr = NULL;
            while(farheapwalk(&heap) != _HEAPEND)
                if(!heap.in_use)
                    total += heap.size;

            sprintf(heapStr, "Free Memory: %7ld", total);
            break;
    }

    if(total != oldMem)
    {
        oldMem = total;
        drawView();
    }
}
